//+------------------------------------------------------------------+
//|                                              Buy  with SL and TP |
//|                               Copyright  2008, smjones          |
//|                                  sjcoinc mod by magft            |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, smjones"
#property link      "sjcoinc2000@yahoo.com"

#include <stdlib.mqh>

#property show_inputs

extern string Note="0 in Entry field means Market Order Buy";
extern int PreviusCandleEntry=1;
extern double Entry = 0.0000;
extern double Lots = 0.01;
extern bool   UseMoneyMgmt = true;
extern double RiskPercent =2.0;
//extern bool   UseStop = true;
//extern bool   UseTakeProfit = true;
extern double StopLoss = 150;
extern double PartialProfit=0;
extern double BreakEven = 0;
extern double TakeProfit = 100;
extern double PreviusCandleDisplace=8;
extern int    MagicNumber= 0;
extern bool   ECNBroker = true;
string Input = " Buy Price ";
int RetryCount = 10;//Will make this number of attempts to get around the trade context busy error.



//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  { 
  double Risk = RiskPercent / 100;
  if (UseMoneyMgmt)  
   Lots = NormalizeDouble( AccountBalance()*Risk/StopLoss/(MarketInfo(Symbol(), MODE_TICKVALUE)),2); 
  int Mode = OP_BUYSTOP;
//sandi previus candle entry .. order displace
      double PrevHigh=(MathAbs(iHigh(NULL,0,PreviusCandleEntry))); 
      double PrevLow=(MathAbs(iLow(NULL,0,PreviusCandleEntry)));
      double Spread = 0;//MarketInfo(Symbol(),MODE_SPREAD)*Point;///10;
      if (PreviusCandleEntry>0) Entry=PrevHigh + Spread + PreviusCandleDisplace *Point;
  
  if (Ask > Entry && Entry > 0) Mode = OP_BUYLIMIT; 
  if (Entry == 0)  {Entry = Ask; Mode = OP_BUY;}
  double SLB = Entry - StopLoss*Point, TPB = Entry + TakeProfit*Point;

//  if (UseStop == false) SLB = 0;
//  if (UseTakeProfit == false) TPB = 0;
   if (StopLoss==0)  SLB = 0;
   if (TakeProfit == false) TPB = 0;
   
  if(Lots > 0)

      Print("BuyScriptEnter..PreviusEnter:" + PreviusCandleEntry + " PrevH:" + PrevHigh + " Spread:" + Spread + " Ent:" + Entry  + " SL:" + StopLoss);

      SendSingleTrade(Symbol(),Mode,"Buy Script", Lots, Entry, SLB , TPB);

      //popravi TP
      Sleep(2000);
      double PartialCalc = Entry + TakeProfit*Point;      
      ObjectSet("lvoe_tp_"+OrderTicket(),OBJPROP_PRICE1,PartialCalc);//*Point)

      //Popravi Partial stop
      if(PartialProfit!=0){// e je partial 0 potem ni ne spreminja
          Sleep(1000);
          PartialCalc = Entry + PartialProfit *Point;
          ObjectSet("lvoe_cp_"+OrderTicket(),OBJPROP_PRICE1,PartialCalc);//*Point)
      }  

      //Popravi BreakEven
      if(PartialProfit!=0){// e je BE 0 potem ni ne spreminja
            Sleep(1000);
            PartialCalc = Entry + BreakEven*Point;
      ObjectSet("lvoe_be_"+OrderTicket(),OBJPROP_PRICE1,PartialCalc);//*Point)
      }

           
   return(0);
  }
//+------------------------------------------------------------------+
bool SendSingleTrade(string symbol, int type, string comment, double lotsize, double price, double stop, double take)
{
   //pah (Paul) contributed the code to get around the trade context busy error. Many thanks, Paul.
 
   int slippage = 10;
   if (Digits == 3 || Digits == 5) slippage = 100;
   
   int expiry = 0;
   //if (SendPendingTrades) expiry = TimeCurrent() + (PendingExpiryMinutes * 60);
   //RetryCount is declared as 10 in the Trading variables section at the top of this file
   for (int cc = 0; cc < RetryCount; cc++)
   {
      for (int d = 0; (d < RetryCount) && IsTradeContextBusy(); d++) Sleep(100);

      if (!ECNBroker) int ticket = OrderSend(symbol, type, lotsize, price, slippage, stop, take, comment, MagicNumber, expiry, LimeGreen);
   
   
      //Is a 2 stage criminal
      if (ECNBroker)
      {
         ticket = OrderSend(symbol, type, lotsize, price, slippage, 0, 0, comment, MagicNumber, expiry, LimeGreen);
         if (ticket > -1)
         {
	           ModifyOrder(ticket, stop, take);
         }//if (ticket > 0)}
      }//if (ECNBroker)
      
      //Error trapping for both
      if (ticket < 0)
      {
         string stype;
         if (type == OP_BUY) stype = "OP_BUY";
         if (type == OP_SELL) stype = "OP_SELL";
         if (type == OP_BUYLIMIT) stype = "OP_BUYLIMIT";
         if (type == OP_SELLLIMIT) stype = "OP_SELLLIMIT";
         if (type == OP_BUYSTOP) stype = "OP_BUYSTOP";
         if (type == OP_SELLSTOP) stype = "OP_SELLSTOP";
         int err=GetLastError();
         Alert(symbol, " ", stype," order send failed with error(",err,"): ",ErrorDescription(err));
         Print(symbol, " ", stype," order send failed with error(",err,"): ",ErrorDescription(err));
         return(false);
      }//if (ticket < 0)  

      if (ticket > -1) break;//Exit the trade send loop
      if (cc == RetryCount - 1) return(false);

   }//for (int cc = 0; cc < RetryCount; cc++);
   
}

void ModifyOrder(int ticket, double stop, double take)
{
   //Modifies an order already sent if the crim is ECN.
   if (!OrderSelect(ticket, SELECT_BY_TICKET) ) return;//Trade does not exist, so no mod needed
   
   //RetryCount is declared as 10 in the Trading variables section at the top of this file   
   for (int cc = 0; cc < RetryCount; cc++)
   {
      for (int d = 0; (d < RetryCount) && IsTradeContextBusy(); d++) Sleep(100);
        if (take > 0 && stop > 0)
        {
           while(IsTradeContextBusy()) Sleep(100);
           if (OrderModify(ticket, OrderOpenPrice(), stop, take, OrderExpiration(), CLR_NONE)) return;           
        }//if (take > 0 && stop > 0)
   
        if (take != 0 && stop == 0)
        {
           while(IsTradeContextBusy()) Sleep(100);
           if (OrderModify(ticket, OrderOpenPrice(), OrderStopLoss(), take, OrderExpiration(), CLR_NONE)) return;
        }//if (take == 0 && stop != 0)

        if (take == 0 && stop != 0)
        {
           while(IsTradeContextBusy()) Sleep(100);
           if (OrderModify(ticket, OrderOpenPrice(), stop, OrderTakeProfit(), OrderExpiration(), CLR_NONE)) return;
        }//if (take == 0 && stop != 0)
   }//for (int cc = 0; cc < RetryCount; cc++)
   
   //Got this far, so the order modify failed
   int err=GetLastError();
   Print(Symbol(), " SL/TP  order modify failed with error(",err,"): ",ErrorDescription(err));               
   Alert(Symbol(), " SL/TP  order modify failed with error(",err,"): ",ErrorDescription(err));               

}//void ModifyOrder(int ticket, double tp, double sl)